## wireshark-3.7.2.tar.xz

=== CMakeLists.txt ===
# CMakeLists.txt
#
# Wireshark - Network traffic analyzer
# By Gerald Combs <gerald@wireshark.org>
# Copyright 1998 Gerald Combs
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
if(DEFINED ENV{FORCE_CMAKE_NINJA_NON_VERBOSE})
	#
	# Forcibly unset CMAKE_VERBOSE_MAKEFILE,
	# to make *CERTAIN* that we don't do
	# anything verbose here!
	#
	unset(CMAKE_VERBOSE_MAKEFILE CACHE)
endif()

if(WIN32)
	# Needed for add_custom_command() WORKING_DIRECTORY generator expressions
	cmake_minimum_required(VERSION 3.13)
else()
	cmake_minimum_required(VERSION 3.10)
endif()
if(POLICY CMP0074)
	cmake_policy(SET CMP0074 NEW)
endif()
if(POLICY CMP0083)
	cmake_policy(SET CMP0083 NEW)
endif()

if(WIN32)
	set(_project_name Wireshark)
	set(_log_project_name Logray)
else()
	set(_project_name wireshark)
	set(_log_project_name logray)
endif()

project(${_project_name} C CXX)

# Updated by tools/make-version.py
set(PROJECT_MAJOR_VERSION 3)
set(PROJECT_MINOR_VERSION 7)
set(PROJECT_PATCH_VERSION 2)
set(PROJECT_BUILD_VERSION 0)
set(PROJECT_VERSION_EXTENSION "")

if(DEFINED ENV{WIRESHARK_VERSION_EXTRA})
	set(PROJECT_VERSION_EXTENSION "$ENV{WIRESHARK_VERSION_EXTRA}")
endif()

set(PROJECT_VERSION "${PROJECT_MAJOR_VERSION}.${PROJECT_MINOR_VERSION}.${PROJECT_PATCH_VERSION}${PROJECT_VERSION_EXTENSION}")

set(LOG_PROJECT_NAME ${_log_project_name})
set(LOG_PROJECT_MAJOR_VERSION 0)
set(LOG_PROJECT_MINOR_VERSION 8)
set(LOG_PROJECT_VERSION "${LOG_PROJECT_MAJOR_VERSION}.${LOG_PROJECT_MINOR_VERSION}.${PROJECT_PATCH_VERSION}${PROJECT_VERSION_EXTENSION}")

include( CMakeOptions.txt )

# We require minimum C11
set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)

# We require minimum C++11
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

message(STATUS "Generating build using CMake ${CMAKE_VERSION}")

# Set a default build type if none was specified
set(_default_build_type "RelWithDebInfo")
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
	set(CMAKE_BUILD_TYPE "${_default_build_type}" CACHE STRING "Choose the type of build." FORCE)
	# Set the possible values of build type for cmake-gui
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

# Build type is ignored by multi-config generators.
if (NOT CMAKE_CONFIGURATION_TYPES)
	message(STATUS "Using \"${CMAKE_GENERATOR}\" generator and build type \"${CMAKE_BUILD_TYPE}\"")
else()
	message(STATUS "Using \"${CMAKE_GENERATOR}\" generator (multi-config)")
endif()

#Where to find local cmake scripts
set(WS_CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
set(CMAKE_MODULE_PATH ${WS_CMAKE_MODULE_PATH})

# CMake >= 3.9.0 supports LTO/IPO.
if (ENABLE_LTO)
	include(CheckIPOSupported)
	check_ipo_supported(RESULT lto_supported OUTPUT lto_output)
	if(lto_supported)
		set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_RELEASE TRUE)
		message(STATUS "LTO/IPO is enabled for Release configuration")
	else()
		message(STATUS "LTO/IPO requested but it is not supported by the compiler: ${lto_output}")
	endif()
else()
	message(STATUS "LTO/IPO is not enabled")
endif()

# If our target platform is enforced by our generator, set
# WIRESHARK_TARGET_PLATFORM accordingly. Otherwise use
# %WIRESHARK_TARGET_PLATFORM%.

if(WIN32)
	# Are we using MSYS2? If we are we don't use our own third party
	# libraries.
	if(DEFINED ENV{MSYSTEM})
		set(_msystem $ENV{MSYSTEM})
		set(_repository False)
		message(STATUS "Using MSYS2 with MSYSTEM=${_msystem}")
	else()
		set(_msystem False)
		set(_repository True)
		message(STATUS "Using 3rd party repository")
	endif()
	set(USE_MSYSTEM ${_msystem} CACHE INTERNAL "Use MSYS2 subsystem")
	set(USE_REPOSITORY ${_repository} CACHE INTERNAL "Use Wireshark 3rd Party Repository")

	if(DEFINED ENV{WIRESHARK_TARGET_PLATFORM})
		string(TOLOWER $ENV{WIRESHARK_TARGET_PLATFORM} _target_platform)
		set(WIRESHARK_TARGET_PLATFORM ${_target_platform})
	elseif(USE_MSYSTEM MATCHES "MINGW64")
		set(WIRESHARK_TARGET_PLATFORM win64)
	elseif(USE_MSYSTEM MATCHES "MINGW32")
		set(WIRESHARK_TARGET_PLATFORM win32)
	elseif(USE_MSYSTEM)
		message(WARNING "Building for MSYSTEM=${USE_MSYSTEM} is not officially supported")
	elseif(CMAKE_CL_64 OR CMAKE_GENERATOR MATCHES "Win64")
		set(WIRESHARK_TARGET_PLATFORM win64)
	elseif(CMAKE_GENERATOR MATCHES "Visual Studio")
		set(WIRESHARK_TARGET_PLATFORM win32)
	else()
		message(WARNING "Assuming \"win64\" target platform")
		set(WIRESHARK_TARGET_PLATFORM win64)
	endif()

	if(WIRESHARK_TARGET_PLATFORM MATCHES "win64")
		set(WIRESHARK_TARGET_PROCESSOR_ARCHITECTURE amd64)
	elseif(WIRESHARK_TARGET_PLATFORM MATCHES "win32")
		message(FATAL_ERROR "Deprecated target platform ${WIRESHARK_TARGET_PLATFORM}. See https://gitlab.com/wireshark/wireshark/-/issues/17779 for details.")
		set(WIRESHARK_TARGET_PROCESSOR_ARCHITECTURE x86)
	else()
		message(FATAL_ERROR "Invalid target platform: ${WIRESHARK_TARGET_PLATFORM}")
	endif()

	# Sanity check
	if(MSVC)
		if(DEFINED ENV{PLATFORM})
			string(TOLOWER $ENV{PLATFORM} _vs_platform)
		else()
			set(_vs_platform "[undefined]") # x86
		endif()
		if(
			(_vs_platform STREQUAL "x64" AND NOT WIRESHARK_TARGET_PLATFORM STREQUAL "win64")
			OR
			(_vs_platform STREQUAL "[undefined]" AND NOT WIRESHARK_TARGET_PLATFORM STREQUAL "win32")
		)
			message(FATAL_ERROR "The PLATFORM environment variable (${_vs_platform})"
				" doesn't match the generator platform (${WIRESHARK_TARGET_PLATFORM})")
		endif()
	endif()
	message(STATUS
		"Building for ${WIRESHARK_TARGET_PLATFORM} \
and CPU target ${WIRESHARK_TARGET_PROCESSOR_ARCHITECTURE}"
	)

	# Determine where the 3rd party libraries will be
	if(USE_REPOSITORY)
		find_package(PowerShell REQUIRED)

		if( DEFINED ENV{WIRESHARK_LIB_DIR} )
			# The buildbots set WIRESHARK_LIB_DIR but not WIRESHARK_BASE_DIR.
			file( TO_CMAKE_PATH "$ENV{WIRESHARK_LIB_DIR}" _PROJECT_LIB_DIR )
		elseif( DEFINED ENV{WIRESHARK_BASE_DIR} )
			file( TO_CMAKE_PATH "$ENV{WIRESHARK_BASE_DIR}" _WS_BASE_DIR )
			set( _PROJECT_LIB_DIR "${_WS_BASE_DIR}/wireshark-${WIRESHARK_TARGET_PLATFORM}-libs" )
		else()
			# Don't know what to do
			message(FATAL_ERROR "Neither WIRESHARK_BASE_DIR or WIRESHARK_LIB_DIR are defined")
		endif()

		# Download third-party libraries
		file (TO_NATIVE_PATH ${CMAKE_SOURCE_DIR}/tools/win-setup.ps1 _win_setup)
		file (TO_NATIVE_PATH ${_PROJECT_LIB_DIR} _ws_lib_dir)
		file (TO_NATIVE_PATH ${CMAKE_COMMAND} _win_cmake_command)

		# Is it possible to have a one-time, non-cached option in CMake? If
		# so, we could add a "-DFORCE_WIN_SETUP" which passes -Force to
		# win-setup.ps1.
		execute_process(
			COMMAND ${POWERSHELL_COMMAND} "\"${_win_setup}\"" -Destination "${_ws_lib_dir}" -Platform ${WIRESHARK_TARGET_PLATFORM} -CMakeExecutable "\"${_win_cmake_command}\""
			RESULT_VARIABLE _win_setup_failed
			ERROR_VARIABLE _win_setup_error_output
		)
		if(_win_setup_failed)
			message(FATAL_ERROR "Windows setup (win-setup.ps1) failed: ${_win_setup_error_output}.")
		endif()

		set(EXTRA_INSTALLER_DIR ${_ws_lib_dir})

		# XXX Add a dependency on ${_ws_lib_dir}/current_tag.txt?
	endif()
endif(WIN32)

include(UseCustomIncludes)
ADD_CUSTOM_CMAKE_INCLUDE()

# Ensure that all executables and libraries end up in the same directory. Actual
# files might end up in a configuration subdirectory, e.g. run/Debug or
# run/Release. We try to set DATAFILE_DIR to actual location below.
if(NOT ARCHIVE_OUTPUT_PATH)
	set(ARCHIVE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/run CACHE INTERNAL
		   "Single output directory for building all archives.")
endif()
if(NOT EXECUTABLE_OUTPUT_PATH)
	set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/run CACHE INTERNAL
		   "Single output directory for building all executables.")
endif()
if(NOT LIBRARY_OUTPUT_PATH)
	set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/run CACHE INTERNAL
		   "Single output directory for building all libraries.")
endif()

#
# The release mode (CMAKE_BUILD_TYPE=release) defines NDEBUG for
# the Unix Makefile generator.
#

# Defines CMAKE_INSTALL_BINDIR, CMAKE_INSTALL_DATADIR, etc ...
if(WIN32)
	# Override some values on Windows, to match the existing
	# convention of installing everything to a single root folder.
	set(CMAKE_INSTALL_BINDIR ".")
	set(CMAKE_INSTALL_LIBDIR ".")
	set(CMAKE_INSTALL_INCLUDEDIR "include")
	set(CMAKE_INSTALL_DATADIR ".")
	set(CMAKE_INSTALL_DOCDIR ".")
else()
	# By default INSTALL_DATADIR is set to INSTALL_DATAROOTDIR, set the
	# proper value here.
	set(CMAKE_INSTALL_DATADIR "share/${PROJECT_NAME}"
		CACHE PATH "Read-only architecture-independent data"
	)
endif()
include(GNUInstallDirs)

set(PROJECT_INSTALL_INCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}")

# Make sure our executables can load our libraries if we install into
# a non-default directory on Unix-like systems other than macOS.
# https://gitlab.kitware.com/cmake/community/wikis/doc/cmake/RPATH-handling
set(LIBRARY_INSTALL_RPATH "")
set(EXECUTABLE_INSTALL_RPATH "")
set(EXTCAP_INSTALL_RPATH "")
if(NOT (WIN32 OR APPLE OR USE_STATIC))
	# Try to set a RPATH for installed binaries if the library directory is
	# not already included in the default search list.
	list(FIND CMAKE_C_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_FULL_LIBDIR}" IS_SYSTEM_DIR)
	if(IS_SYSTEM_DIR EQUAL -1)
		# Some systems support $ORIGIN in RPATH to enable relocatable
		# binaries. In other cases, only absolute paths can be used.
		# https://www.lekensteyn.nl/rpath.html
		if(CMAKE_SYSTEM_NAME MATCHES "^(Linux|SunOS|FreeBSD)$")
			set(_enable_rpath_origin TRUE)
			if(BUILD_dumpcap AND ENABLE_PCAP)
				# dumpcap will most likely be installed with
				# capabilities or setuid. Relative RPATHs that
				# resolve to non-standard library directories
				# are ignored for such binaries and since we
				# cannot achieve relocatable builds, just
				# disable it by default.
				set(_enable_rpath_origin FALSE)
			endif()
			# Provide a knob to optionally force absolute rpaths,
			# to support old/buggy systems and as a user preference
			# for hardening.
			set(ENABLE_RPATH_ORIGIN ${_enable_rpath_origin} CACHE BOOL
				"Use $ORIGIN with INSTALL_RPATH")
			mark_as_advanced(ENABLE_RPATH_ORIGIN)
		else()
			set(ENABLE_RPATH_ORIGIN FALSE)
		endif()
		if(ENABLE_RPATH_ORIGIN)
			set(LIBRARY_INSTALL_RPATH     "$ORIGIN")
			set(EXECUTABLE_INSTALL_RPATH  "$ORIGIN/../${CMAKE_INSTALL_LIBDIR}")
			set(EXTCAP_INSTALL_RPATH      "$ORIGIN/../..")
		else()
			set(LIBRARY_INSTALL_RPATH     "${CMAKE_INSTALL_FULL_LIBDIR}")
			set(EXECUTABLE_INSTALL_RPATH  "${CMAKE_INSTALL_FULL_LIBDIR}")
			set(EXTCAP_INSTALL_RPATH      "${CMAKE_INSTALL_FULL_LIBDIR}")
		endif()
		# Include non-standard external libraries by default in RPATH.
		if(NOT DEFINED CMAKE_INSTALL_RPATH_USE_LINK_PATH)
			set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
		endif()
	endif()
endif()

# Ensure that executables in the build directory always have the same RPATH.
# This ensures relocatable binaries and reproducible builds (invariant of the
# build directory location). (Requires CMake 3.14)
set(CMAKE_BUILD_RPATH_USE_ORIGIN ON)

if(MSVC)
    # Linking with wsetargv.obj enables "wildcard expansion" of
    # command-line arguments.
    set(WILDCARD_OBJ wsetargv.obj)
endif()

include(CheckSymbolExists)

#
# Large file support on UN*X, a/k/a LFS.
#
# On Windows, we require _fseeki64() and _ftelli64().  Visual
# Studio has had supported them since Visual Studio 2005/MSVCR80,
# and we require newer versions, so we know we have them.
#
if(NOT WIN32)
	include(FindLFS)
	if(LFS_FOUND)
		#
		# Add the required #defines.
		#
		add_definitions(${LFS_DEFINITIONS})
	endif()

	#
	# Check for fseeko as well.
	#
	include(FindFseeko)
	if(FSEEKO_FOUND)
		set(HAVE_FSEEKO ON)

		#
		# Add the required #defines.
		#
		add_definitions(${FSEEKO_DEFINITIONS})
	endif()
endif()

# Banner shown at top right of Qt welcome screen.
if(DEFINED ENV{WIRESHARK_VERSION_FLAVOR})
	set(VERSION_FLAVOR "$ENV{WIRESHARK_VERSION_FLAVOR}")
else()
	set(VERSION_FLAVOR "Development Build")
endif()

# Used in .rc files and manifests

=== epan/dissectors/CMakeLists.txt ===
# CMakeLists.txt
#
# Wireshark - Network traffic analyzer
# By Gerald Combs <gerald@wireshark.org>
# Copyright 1998 Gerald Combs
#
# SPDX-License-Identifier: GPL-2.0-or-later
#

ADD_CUSTOM_CMAKE_INCLUDE()

add_subdirectory(asn1 EXCLUDE_FROM_ALL)
add_subdirectory(dcerpc EXCLUDE_FROM_ALL)
add_subdirectory(pidl EXCLUDE_FROM_ALL)

add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/packet-ncp2222.c
	COMMAND ${PYTHON_EXECUTABLE}
		${CMAKE_SOURCE_DIR}/tools/ncp2222.py
		-o ${CMAKE_CURRENT_BINARY_DIR}/packet-ncp2222.c
	DEPENDS
		packet-ncp2222.inc
		${CMAKE_SOURCE_DIR}/tools/ncp2222.py
)

add_custom_target(x11-dissector
	COMMAND ${PERL_EXECUTABLE}
		${CMAKE_SOURCE_DIR}/tools/process-x11-fields.pl ${CMAKE_CURRENT_SOURCE_DIR}
		< ${CMAKE_CURRENT_SOURCE_DIR}/x11-fields
	COMMAND ${PERL_EXECUTABLE}
		${CMAKE_SOURCE_DIR}/tools/process-x11-xcb.pl ${CMAKE_CURRENT_SOURCE_DIR}
	DEPENDS
		x11-fields
		${CMAKE_SOURCE_DIR}/tools/process-x11-fields.pl
		${CMAKE_SOURCE_DIR}/tools/process-x11-xcb.pl
		${CMAKE_CURRENT_SOURCE_DIR}/xcbproto
		${CMAKE_CURRENT_SOURCE_DIR}/mesa
)

set_target_properties(x11-dissector PROPERTIES FOLDER "Generated Dissectors/X11")

set(PIDL_DISSECTOR_SRC
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-atsvc.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-budb.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-butc.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-clusapi.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-dfs.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-dnsserver.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-drsuapi.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-dssetup.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-efs.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-eventlog.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-frstrans.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-fsrvp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-initshutdown.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-lsa.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-mapi.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-mdssvc.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-misc.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-nspi.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-rfr.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-srvsvc.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-winreg.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-winspool.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-witness.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-wkssvc.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dcerpc-wzcsvc.c
)

set(CLEAN_ASN1_DISSECTOR_SRC
	${CMAKE_CURRENT_SOURCE_DIR}/packet-lix2.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-ansi_map.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-acp133.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-acse.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-ain.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-ansi_tcap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-atn-ulcs.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-atn-cm.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-atn-cpdlc.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-c1222.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-camel.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-cbrs-oids.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-cdt.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-charging_ase.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-cmip.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-cmp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-cms.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-credssp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-crmf.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-disp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dop.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-dsp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-e1ap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-e2ap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-ess.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-f1ap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-ftam.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-gdt.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-glow.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-goose.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-gsm_map.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-HI2Operations.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-h225.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-h235.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-h245.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-h248.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-h282.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-h283.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-h323.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-h450.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-h450-ros.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-h460.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-h501.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-hnbap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-idmp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-idn.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-ilp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-inap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-isdn-sup.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-its.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-kerberos.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-lcsap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-ldap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-lnpdqp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-log3gpp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-logotypecertextn.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-lpp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-lppa.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-lppe.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-lte-rrc.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-m2ap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-m3ap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-mms.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-mpeg-audio.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-mpeg-pes.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-msgpack.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-msrcp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-mudurl.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-nbap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-ngap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-nist-csor.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-novell_pkis.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-nrppa.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-nr-rrc.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-ns_cert_exts.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-ocsp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-oer.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-p1.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-p22.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-p7.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-p772.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-pcap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-pkcs1.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-pkcs10.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-pkcs12.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-pkinit.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-pkix1explicit.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-pkix1implicit.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-pkixac.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-pkixproxy.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-pkixqualified.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-pkixtsp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-pres.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-q932.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-q932-ros.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-qsig.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-ranap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-rnsap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-roon_discovery.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-ros.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-rrc.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-rrlp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-rtse.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-rua.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-s1ap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-sabp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-sbc-ap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-smrse.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-snmp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-spnego.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-sv.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-systemd-journal.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-t124.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-t125.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-t38.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-tcap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-tetra.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-ulp.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-wireguard.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-wlancertextn.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-x2ap.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-x509af.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-x509ce.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-x509if.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-x509sat.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-xnap.c
)

set(DIRTY_ASN1_DISSECTOR_SRC
)

set(ASN1_DISSECTOR_SRC
	${CLEAN_ASN1_DISSECTOR_SRC}
	${DIRTY_ASN1_DISSECTOR_SRC}
)

set(DIRTY_CORBA_IDL_DISSECTOR_SRC
	${CMAKE_CURRENT_SOURCE_DIR}/packet-cosnaming.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-gias.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-parlay.c
	${CMAKE_CURRENT_SOURCE_DIR}/packet-tango.c
)

set(CLEAN_CORBA_IDL_DISSECTOR_SRC
	${CMAKE_CURRENT_SOURCE_DIR}/packet-coseventcomm.c
)

set(CORBA_IDL_DISSECTOR_SRC
	${CLEAN_CORBA_IDL_DISSECTOR_SRC}
	${DIRTY_CORBA_IDL_DISSECTOR_SRC}
)

source_group(dissectors-corba FILES ${CORBA_IDL_DISSECTOR_SRC})

add_library(dissectors-corba OBJECT
	${CORBA_IDL_DISSECTOR_SRC}
)

set_target_properties(dissectors-corba PROPERTIES
	FOLDER "Libs/epan/dissectors"
	COMPILE_DEFINITIONS "WS_BUILD_DLL"
)

if(WIN32 AND CMAKE_GENERATOR STREQUAL "Visual Studio 12 2013 Win64")
	# CORBA IDL dissectors are triggering a MSVC 2013 x64 /O2 bug leading to a NULL pointer dereference (see bug 12495)
	target_compile_options(dissectors-corba PRIVATE $<$<CONFIG:Release>:/Ox> $<$<CONFIG:RelWithDebInfo>:/Ox>)
endif()

set(NCP2222_DISSECTOR_SRC
	${CMAKE_CURRENT_BINARY_DIR}/packet-ncp2222.c
)

source_group(dissectors-ncp2222 FILES ${NCP2222_DISSECTOR_SRC})

set(DISSECTOR_PUBLIC_HEADERS
	cond_ace_token_enum.h
	file-rbm.h
	packet-6lowpan.h
	packet-a21.h
	packet-acdr.h
	packet-acp133.h
	packet-acse.h
	packet-actrace.h
	packet-adb_service.h
	packet-afp.h
	packet-alcap.h
	packet-amp.h
	packet-ansi_a.h
	packet-ansi_map.h
	packet-ansi_tcap.h
	packet-arp.h
	packet-asap+enrp-common.h
	packet-atalk.h
	packet-atm.h
	packet-atn-ulcs.h
	packet-autosar-ipdu-multiplexer.h
	packet-bacapp.h
	packet-bacnet.h
	packet-ber.h
	packet-bfd.h
	packet-bgp.h
	packet-bicc_mst.h
	packet-bluetooth.h
	packet-bpv6.h
	packet-bpv7.h
	packet-bpsec.h
	packet-bssap.h
	packet-bssgp.h
	packet-btatt.h
	packet-btavctp.h
	packet-btavdtp.h
	packet-btavrcp.h
	packet-btbredr_rf.h
	packet-bthci_acl.h
	packet-bthci_cmd.h
	packet-bthci_evt.h
	packet-bthci_iso.h
	packet-bthci_sco.h
	packet-btl2cap.h
	packet-btle.h
	packet-btrfcomm.h
	packet-btsdp.h
	packet-c1222.h
	packet-camel.h
	packet-cdt.h
	packet-cell_broadcast.h
	packet-charging_ase.h
	packet-chdlc.h
	packet-cip.h
	packet-cipsafety.h
	packet-cmip.h
	packet-cmp.h
	packet-cms.h
	packet-coap.h
	packet-cose.h
	packet-credssp.h
	packet-crmf.h
	packet-csn1.h
	packet-dap.h
	packet-dcc.h
	packet-dccp.h
	packet-dcerpc.h
	packet-dcerpc-browser.h
	packet-dcerpc-budb.h
	packet-dcerpc-butc.h
	packet-dcerpc-dce122.h
	packet-dcerpc-dnsserver.h
	packet-dcerpc-frsapi.h
	packet-dcerpc-frsrpc.h
	packet-dcerpc-netlogon.h
	packet-dcerpc-nt.h
	packet-dcerpc-pnp.h
	packet-dcerpc-rras.h
	packet-dcerpc-samr.h
	packet-dcerpc-spoolss.h
	packet-dcerpc-svcctl.h
	packet-dcerpc-tapi.h
	packet-dcom.h
	packet-dcom-dispatch.h
	packet-diameter.h
	packet-diameter_3gpp.h
	packet-diffserv-mpls-common.h
	packet-disp.h
	packet-dlt.h
	packet-dns.h
	packet-docsis-tlv.h
	packet-doip.h
	packet-dop.h
	packet-dsp.h
	packet-dtls.h
	packet-dvbci.h
	packet-e1ap.h
	packet-enip.h
	packet-erf.h
	packet-e164.h
	packet-e212.h
	packet-eapol.h
	packet-edonkey.h
	packet-eigrp.h
	packet-epl.h
	packet-epmd.h
	packet-ess.h
	packet-eth.h
	packet-f1ap.h
	packet-f5ethtrailer.h
	packet-fc.h
	packet-fcbls.h
	packet-fcct.h
	packet-fcels.h
	packet-fcfcs.h
	packet-fcfzs.h
	packet-fclctl.h
	packet-fcsb3.h
	packet-fcswils.h
	packet-ff.h
	packet-fix.h
	packet-flexray.h
	packet-fmp.h
	packet-frame.h
	packet-ftam.h
	packet-ftdi-ft.h
	packet-geonw.h
	packet-giop.h
	packet-gluster.h
	packet-gmr1_common.h
	packet-gmr1_rr.h
	packet-gprscdr.h
	packet-gre.h
	packet-gsm_a_common.h
	packet-gsm_a_rr.h
	packet-gsm_map.h
	packet-gsm_rlcmac.h
	packet-gsm_sms.h
	packet-gsmtap.h
	packet-gssapi.h
	packet-gtp.h
	packet-gtpv2.h
	packet-h223.h
	packet-h225.h
	packet-h235.h
	packet-h245.h
	packet-h248.h

=== packaging/nsis/CMakeLists.txt ===
# CMakeLists.txt
#
# Wireshark - Network traffic analyzer
# By Gerald Combs <gerald@wireshark.org>
# Copyright 1998 Gerald Combs
#
# SPDX-License-Identifier: GPL-2.0-or-later
#

# We should use CPack to generate the NSIS package. Even better,
# we should use CPack to create a .msi using WiX.

set(WIRESHARK_NSIS_GENERATED_FILES
	${CMAKE_CURRENT_BINARY_DIR}/wireshark-manifest.nsh
	${CMAKE_CURRENT_BINARY_DIR}/wireshark-config.nsh
	${CMAKE_CURRENT_BINARY_DIR}/wireshark-qt-manifest.nsh
)
set(WIRESHARK_NSIS_GENERATED_FILES ${WIRESHARK_NSIS_GENERATED_FILES} PARENT_SCOPE)

set(WIRESHARK_NSIS_FILES
	wireshark.nsi
	uninstall-wireshark.nsi
	wireshark-common.nsh
	GetWindowsVersion.nsh
	servicelib.nsh
	AdditionalTasksPage.ini
	NpcapPage.ini
	USBPcapPage.ini
	${WIRESHARK_NSIS_GENERATED_FILES}
	PARENT_SCOPE
)

set(LOGRAY_NSIS_GENERATED_FILES
	${CMAKE_CURRENT_BINARY_DIR}/logray-manifest.nsh
	${CMAKE_CURRENT_BINARY_DIR}/logray-config.nsh
	${CMAKE_CURRENT_BINARY_DIR}/logray-qt-manifest.nsh
)
set(LOGRAY_NSIS_GENERATED_FILES ${LOGRAY_NSIS_GENERATED_FILES} PARENT_SCOPE)

set(LOGRAY_NSIS_FILES
	logray.nsi
	uninstall-logray.nsi
	logray-common.nsh
	GetWindowsVersion.nsh
	servicelib.nsh
	AdditionalTasksPage.ini
	NpcapPage.ini
	USBPcapPage.ini
	${LOGRAY_NSIS_GENERATED_FILES}
	PARENT_SCOPE
)

# Variables required for config.nsh
set(PROGRAM_NAME ${CMAKE_PROJECT_NAME})
set(LOG_PROGRAM_NAME ${LOG_PROJECT_NAME})
file(TO_NATIVE_PATH "${CMAKE_SOURCE_DIR}" TOP_SRC_DIR)
# STAGING_DIR depends on the build configuration so we pass it
# on the command line below.
file(TO_NATIVE_PATH "${CMAKE_BINARY_DIR}/docbook" DOCBOOK_DIR)
if(WIRESHARK_TARGET_PLATFORM STREQUAL "win32")
        set(TARGET_MACHINE x86)
elseif(WIRESHARK_TARGET_PLATFORM STREQUAL "win64")
        set(TARGET_MACHINE x64)
else()
        message(FATAL_ERROR "Your mysterious moon-man architecture \"${WIRESHARK_TARGET_PLATFORM}\" frightens and confuses us.")
endif()
set (MMDBRESOLVE_EXE ${MAXMINDDB_FOUND})

# Must match ${EXTRA_INSTALLER_DIR}/Npcap-X.Y.Z.exe
set(NPCAP_PACKAGE_VERSION "1.60")

set(USBPCAP_PACKAGE_VERSION "1.5.4.0")

# To do:
# - Sync the various version names between CMake and NSIS.
# - Set CMakeLists.txt version strings in tools/make-version.py
# - Add a VERSION_EXTRA cmake option
set (PRODUCT_VERSION ${PROJECT_MAJOR_VERSION}.${PROJECT_MINOR_VERSION}.${PROJECT_PATCH_VERSION}.${PROJECT_BUILD_VERSION})
set (LOG_PRODUCT_VERSION ${LOG_PROJECT_MAJOR_VERSION}.${LOG_PROJECT_MINOR_VERSION}.${PROJECT_PATCH_VERSION}.${PROJECT_BUILD_VERSION})

#add_custom_target(build_nsis_package
#	DEPENDS
#		wireshark-$(WIRESHARK_TARGET_PLATFORM)-$(VERSION).exe
#)

if((BUILD_wireshark OR BUILD_logray) AND QT_FOUND)
	set (QT_DIR "\${STAGING_DIR}")
endif()

# Look for the Visual C++ Redistributable packages in the following locations:
# - _PROJECT_LIB_DIR
# - _PROJECT_LIB_DIR/vcredist_MSVCxx
# - %VCINSTALLDIR%
# - %VCINSTALLDIR%/redist/1033 (<= Visual Studio 2015)
# - %VCINSTALLDIR%/Redist/MSVC/* (>= Visual Studio 2017)
# MSVC_VERSION (_MSC_VER) = Visual Studio Version / MSVC Toolset Version
# 1900 = VS2015 14.0        / 14.00
# 1910 = VS2017 15.1, 15.2  / 14.10
# 1911 = VS2017 15.3, 15.4  / 14.11
# 1912 = VS2017 15.5        / 14.12
# 1913 = VS2017 15.6        / 14.13
# 1914 = VS2017 15.7        / 14.14
if(MSVC_VERSION GREATER_EQUAL 1930)
	set(_ws_vcredist_subdir "vcredist_MSVC2022")
elseif(MSVC_VERSION GREATER_EQUAL 1920)
	set(_ws_vcredist_subdir "vcredist_MSVC2019")
	set(_msvs_version 15.0) # Doesn't appear to be set
elseif(MSVC_VERSION GREATER_EQUAL 1910)
	set(_ws_vcredist_subdir "vcredist_MSVC2017")
	set(_msvs_version 15.0)
elseif(MSVC_VERSION GREATER_EQUAL 1900)
	set(_ws_vcredist_subdir "vcredist_MSVC2015")
	set(_ms_vcredist_subdir "redist/1033")
	set(_msvs_version 14.0)
endif()

# Try to find the Redist folder in VCINSTALLDIR which is set by vcvarsall.bat.
# If it is not set, query it within the registry. VS2015 looks for the "VC7" key
# in two locations (four if you count HKCU instead of HKLM). However, VS2017
# does not use "VC7" (it sets a directory relative to vsdevcmd_start.bat). As
# both versions do set "VS7", use that instead.
find_path(VCINSTALLDIR Redist PATHS
	"$ENV{VCINSTALLDIR}"
	"[HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\VisualStudio\\SxS\\VS7;${_msvs_version}]\\VC"
	"[HKEY_LOCAL_MACHINE\\SOFTWARE\\WOW6432Node\\Microsoft\\VisualStudio\\SxS\\VS7;${_msvs_version}]\\VC"
	NO_DEFAULT_PATH
)
file(TO_NATIVE_PATH "${VCINSTALLDIR}" VCINSTALLDIR_NATIVE)
message(STATUS "Using VCINSTALLDIR: ${VCINSTALLDIR_NATIVE}")

# Visual Studio Community 2017 version 15.7.5 uses VCRT 14.14.26405, but an
# earlier version used 14.10.25008. Let's just glob for the right value.
if(MSVC_VERSION GREATER_EQUAL 1910 AND VCINSTALLDIR)
	file(GLOB _ms_vcredist_subdir RELATIVE "${VCINSTALLDIR}"
		"${VCINSTALLDIR}/Redist/MSVC/14.*.*")
endif()

find_program(_vcredist
	NAMES
		"vc_redist.${TARGET_MACHINE}.exe" # Visual Studio 2022 and later
		"vcredist_${TARGET_MACHINE}.exe" # Visual Studio 2019 and earlier
	PATHS "${_PROJECT_LIB_DIR}" $ENV{VCToolsRedistDir} "${VCINSTALLDIR}"
	PATH_SUFFIXES ${_ws_vcredist_subdir} ${_ms_vcredist_subdir}
	NO_DEFAULT_PATH
)
if(_vcredist)
	file(TO_NATIVE_PATH "${_vcredist}" _vcredist)
	message(STATUS "Using ${_vcredist} for the NSIS installer.")
	get_filename_component(VCREDIST_DIR ${_vcredist} DIRECTORY)
	get_filename_component(VCREDIST_EXE ${_vcredist} NAME)
endif()

if (BUILD_wireshark)
	# Ideally we would generate this at compile time using a separate cmake
	# module, e.g. cmake/modules/configure_nsis_file.cmake. However we would
	# have to figure out a clean way to pass in the variables above.
	file(READ "${CMAKE_CURRENT_SOURCE_DIR}/wireshark-config.nsh.in" _config_nsh_contents)
	string(CONFIGURE "${_config_nsh_contents}" _config_nsh_contents)
	string(REPLACE "#define" "!define" _config_nsh_contents "${_config_nsh_contents}")
	string(REPLACE "#undef" "!undef" _config_nsh_contents "${_config_nsh_contents}")
	file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/wireshark-config.nsh" "${_config_nsh_contents}")

	# wireshark-manifest.nsh. Can be created at configure time.
	set(_all_manifest "${CMAKE_CURRENT_BINARY_DIR}/wireshark-manifest.nsh")
	set(_all_manifest_contents "# Files required for all sections. Generated by CMake.\n")
	set(_all_manifest_contents "${_all_manifest_contents}!ifdef BUNDLE_DEBUG_DLLS\n")
	foreach(_dll ${GLIB2_DLLS_DEBUG})
		set(_all_manifest_contents "${_all_manifest_contents}File \"\${STAGING_DIR}\\${_dll}\"\n")
	endforeach()
	set(_all_manifest_contents "${_all_manifest_contents}!else\n")
	foreach(_dll ${GLIB2_DLLS_RELEASE})
		set(_all_manifest_contents "${_all_manifest_contents}File \"\${STAGING_DIR}\\${_dll}\"\n")
	endforeach()
	set(_all_manifest_contents "${_all_manifest_contents}!endif\n")
	foreach(_dll ${CARES_DLL} ${PCRE2_DLL} ${GCRYPT_DLLS}
			${GNUTLS_DLLS} ${KERBEROS_DLLS} ${LIBSSH_DLLS} ${LUA_DLL}
			${LZ4_DLL} ${NGHTTP2_DLL} ${SBC_DLL} ${SMI_DLL} ${SNAPPY_DLL}
			${SPANDSP_DLL} ${BCG729_DLL} ${LIBXML2_DLLS} ${WINSPARKLE_DLL}
			${ZLIB_DLL} ${BROTLI_DLLS} ${ZSTD_DLL} ${ILBC_DLL} ${OPUS_DLL}
			# Needed for mmdbresolve
			${MAXMINDDB_DLL}
		)
		set(_all_manifest_contents "${_all_manifest_contents}File \"\${STAGING_DIR}\\${_dll}\"\n")
	endforeach()
	foreach(_script "init.lua" "console.lua" "dtd_gen.lua")
		set(_all_manifest_contents "${_all_manifest_contents}File \"\${STAGING_DIR}\\${_script}\"\n")
	endforeach()
	file(WRITE "${_all_manifest}" "${_all_manifest_contents}")
endif()

if (BUILD_logray)
	# Ideally we would generate this at compile time using a separate cmake
	# module, e.g. cmake/modules/configure_nsis_file.cmake. However we would
	# have to figure out a clean way to pass in the variables above.
	file(READ "${CMAKE_CURRENT_SOURCE_DIR}/logray-config.nsh.in" _config_nsh_contents)
	string(CONFIGURE "${_config_nsh_contents}" _config_nsh_contents)
	string(REPLACE "#define" "!define" _config_nsh_contents "${_config_nsh_contents}")
	string(REPLACE "#undef" "!undef" _config_nsh_contents "${_config_nsh_contents}")
	file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/logray-config.nsh" "${_config_nsh_contents}")

	# logray-manifest.nsh. Can be created at configure time.
	set(_all_manifest "${CMAKE_CURRENT_BINARY_DIR}/logray-manifest.nsh")
	set(_all_manifest_contents "# Files required for all sections. Generated by CMake.\n")
	set(_all_manifest_contents "${_all_manifest_contents}!ifdef BUNDLE_DEBUG_DLLS\n")
	foreach(_dll ${GLIB2_DLLS_DEBUG})
		set(_all_manifest_contents "${_all_manifest_contents}File \"\${STAGING_DIR}\\${_dll}\"\n")
	endforeach()
	set(_all_manifest_contents "${_all_manifest_contents}!else\n")
	foreach(_dll ${GLIB2_DLLS_RELEASE})
		set(_all_manifest_contents "${_all_manifest_contents}File \"\${STAGING_DIR}\\${_dll}\"\n")
	endforeach()
	set(_all_manifest_contents "${_all_manifest_contents}!endif\n")
	foreach(_dll ${CARES_DLL} ${PCRE2_DLL} ${GCRYPT_DLLS}
			${GNUTLS_DLLS} ${KERBEROS_DLLS} ${LIBSSH_DLLS} ${LUA_DLL}
			${LZ4_DLL} ${NGHTTP2_DLL} ${SBC_DLL} ${SMI_DLL} ${SNAPPY_DLL}
			${SPANDSP_DLL} ${BCG729_DLL} ${LIBXML2_DLLS} ${WINSPARKLE_DLL}
			${ZLIB_DLL} ${BROTLI_DLLS} ${ZSTD_DLL} ${ILBC_DLL} ${OPUS_DLL}
			# Needed for mmdbresolve
			${MAXMINDDB_DLL}
		)
		set(_all_manifest_contents "${_all_manifest_contents}File \"\${STAGING_DIR}\\${_dll}\"\n")
	endforeach()
	foreach(_script "init.lua" "console.lua" "dtd_gen.lua")
		set(_all_manifest_contents "${_all_manifest_contents}File \"\${STAGING_DIR}\\${_script}\"\n")
	endforeach()
	file(WRITE "${_all_manifest}" "${_all_manifest_contents}")
endif()

file(TO_NATIVE_PATH "${DATAFILE_DIR}" _staging_dir)
file(TO_NATIVE_PATH "${CMAKE_CURRENT_BINARY_DIR}" _outfile_dir)
file(TO_NATIVE_PATH "${CMAKE_CURRENT_BINARY_DIR}" _nsis_include_dir)

# Variables we can't set via config.nsh.
set(NSIS_OPTIONS
	/DSTAGING_DIR=${_staging_dir}
	/DOUTFILE_DIR=${_outfile_dir}
	/DNSIS_INCLUDE_DIR=${_nsis_include_dir}
	/V2
	PARENT_SCOPE
)

# We want to sign all of the executables that we ship in the official
# installers. This means that uninstall-wireshark.exe must be built
# separately AND that building the installer itself won't overwrite
# uninstall-wireshark.exe
macro( ADD_NSIS_UNINSTALLER_TARGETS )
	set (_nsis_source_dir ${CMAKE_SOURCE_DIR}/packaging/nsis )
	set (_nsis_binary_dir ${CMAKE_BINARY_DIR}/packaging/nsis )

	#
	# XXX - if we're not building Wireshark, we can't build
	# anything, so there's nothing to uninstall.
	#
	if(BUILD_wireshark)
		add_custom_command(OUTPUT ${DATAFILE_DIR}/uninstall-wireshark.exe
			DEPENDS ${_nsis_source_dir}/uninstall-wireshark.nsi
				${_nsis_source_dir}/wireshark-common.nsh
			COMMAND ${MAKENSIS_EXECUTABLE} ${NSIS_OPTIONS}
				uninstall-wireshark.nsi
			COMMAND ${POWERSHELL_COMMAND} "${_nsis_source_dir}/makeUninstall.ps1" ${DATAFILE_DIR}/uninstall_wireshark_installer.exe
			COMMAND ${CMAKE_COMMAND} -E remove ${DATAFILE_DIR}/uninstall_wireshark_installer.exe
			WORKING_DIRECTORY ${_nsis_source_dir}
		)
	else()
		message(WARNING "The NSIS installer cannot be built if the Wireshark program isn't built.")
	endif()

	if(BUILD_logray)
		add_custom_command(OUTPUT ${DATAFILE_DIR}/uninstall-logray.exe
			DEPENDS ${_nsis_source_dir}/uninstall-logray.nsi
				${_nsis_source_dir}/logray-common.nsh
			COMMAND ${MAKENSIS_EXECUTABLE} ${NSIS_OPTIONS}
				uninstall-logray.nsi
			COMMAND ${POWERSHELL_COMMAND} "${_nsis_source_dir}/makeUninstall.ps1" ${DATAFILE_DIR}/uninstall_logray_installer.exe
			COMMAND ${CMAKE_COMMAND} -E remove ${DATAFILE_DIR}/uninstall_logray_installer.exe
			WORKING_DIRECTORY ${_nsis_source_dir}
		)
	endif()
endmacro( ADD_NSIS_UNINSTALLER_TARGETS )

macro( ADD_NSIS_PACKAGE_TARGETS )
	#
	# XXX - if we're not building Wireshark, we can't build the
	# manifest below.  On the other hand, if we're not building
	# Wireshark, we have no need to include Qt in the installer,
	# so it's not clear we need this manifest.
	#
	# This should probably be fixed, so that people can produce
	# command-line-only installer packages.
	if(BUILD_wireshark)

=== plugins/epan/falco_bridge/CMakeLists.txt ===
# CMakeLists.txt
#
# Wireshark - Network traffic analyzer
# By Gerald Combs <gerald@wireshark.org>
# Copyright 1998 Gerald Combs
#
# SPDX-License-Identifier: GPL-2.0-or-later
#

include(WiresharkPlugin)

# Plugin name and version info (major minor micro extra)
set_module_info(falco-bridge 0 0 4 0)

set(DISSECTOR_SRC
	packet-falco-bridge.c
	sinsp-span.cpp
)

set(DISSECTOR_HEADERS
	conversation-macros.h
	sinsp-span.h
)

set(PLUGIN_FILES
	plugin.c
	${DISSECTOR_SRC}
)

set_source_files_properties(
	${PLUGIN_FILES}
	PROPERTIES
	COMPILE_FLAGS "${WERROR_COMMON_FLAGS}"
)

register_plugin_files(plugin.c
	plugin
	${DISSECTOR_SRC}
)

add_logray_plugin_library(falco-bridge epan)

# XXX Hacks; need to fix in falcosecurity-libs.
target_compile_definitions(falco-bridge PRIVATE
	HAVE_STRLCPY=1
	)
# target_compile_options(falco-bridge PRIVATE -Wno-address-of-packed-member)

target_include_directories(falco-bridge SYSTEM PRIVATE
	${SINSP_INCLUDE_DIRS}
)

target_link_libraries(falco-bridge
	epan
	${SINSP_LIBRARIES}
)

install_plugin(falco-bridge epan)

CHECKAPI(
	NAME
	  falco-bridge
	SWITCHES
	  --group dissectors-prohibited
	  --group dissectors-restricted
	SOURCES
	  ${DISSECTOR_SRC}
	  ${DISSECTOR_HEADERS}
)

#
# Editor modelines  -  https://www.wireshark.org/tools/modelines.html
#
# Local variables:
# c-basic-offset: 8
# tab-width: 8
# indent-tabs-mode: t
# End:
#
# vi: set shiftwidth=8 tabstop=8 noexpandtab:
# :indentSize=8:tabSize=8:noTabs=false:
#

=== plugins/epan/pluginifdemo/CMakeLists.txt ===
# CMakeLists.txt
#
# Wireshark - Network traffic analyzer
# By Gerald Combs <gerald@wireshark.org>
# Copyright 1998 Gerald Combs
#
# SPDX-License-Identifier: GPL-2.0-or-later
#

include(WiresharkPlugin)

# Plugin name and version info (major minor micro extra)
set_module_info(pluginifdemo 0 0 1 0)

SET(CMAKE_AUTOMOC ON)
SET(CMAKE_AUTOUIC ON)

find_package(Qt5Core)
find_package(Qt5PrintSupport)
find_package(Qt5Widgets)

set(DISSECTOR_SRC
	pluginifdemo.c
	ui/uihandler.cpp
	ui/uiclasshandler.cpp
	ui/pluginifdemo_main.cpp
	ui/pluginifdemo_about.cpp
	${UI_SRC}
)

set(PLUGIN_FILES
	plugin.c
	${DISSECTOR_SRC}
)

set_source_files_properties(
	plugin.c
	PROPERTIES
	SKIP_AUTOGEN ON
)

set_source_files_properties(
	${PLUGIN_FILES}
	PROPERTIES
	COMPILE_FLAGS "${WERROR_COMMON_FLAGS}"
)

register_plugin_files(plugin.c
	plugin
	${DISSECTOR_SRC}
)

add_wireshark_plugin_library(pluginifdemo epan)

target_link_libraries(pluginifdemo epan Qt5::Core Qt5::Widgets Qt5::PrintSupport Qt5::Multimedia)

install_plugin(pluginifdemo epan)

file(GLOB DISSECTOR_HEADERS RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "*.h")
CHECKAPI(
	NAME
	  pluginifdemo
	SWITCHES
	  --group dissectors-prohibited
	  --group dissectors-restricted
	SOURCES
	  ${DISSECTOR_SRC}
	  ${DISSECTOR_HEADERS}
)

=== packaging/debian/changelog ===
wireshark (3.7.2) unstable; urgency=low

  * Self-made package

 -- Wireshark Self-made package <wireshark@example.com>  Mon, 17 Oct 2016 12:05:44 +0200

=== packaging/debian/control ===
Source: wireshark
Section: net
Priority: optional
Maintainer: Balint Reczey <rbalint@ubuntu.com>
Standards-Version: 3.9.8
Build-Depends:
 qtbase5-dev, qtbase5-dev-tools, qttools5-dev, qttools5-dev-tools,
 qtmultimedia5-dev,
 libpcap0.8-dev, flex, libz-dev, debhelper (>= 12), po-debconf,
 python3, python3-ply, libc-ares-dev, xsltproc, dh-python,
 docbook-xsl (>= 1.64.1.0-0), docbook-xml, libxml2-utils, libpcre3-dev,
 libcap2-dev [linux-any] | libcap-dev (>= 2.17) [linux-any], lsb-release,
 quilt, libparse-yapp-perl,
# libgnutls28-dev >= 3.2.14-1 is GPLv2+ compatible.
 libgnutls28-dev (>= 3.2.14-1~),
 libgcrypt-dev, libkrb5-dev, liblua5.2-dev, libsmi2-dev,
 libmaxminddb-dev, dpkg-dev (>= 1.16.1~), libsystemd-dev | libsystemd-journal-dev,
 libnl-genl-3-dev [linux-any], libnl-route-3-dev [linux-any], asciidoctor,
 cmake (>= 3.5) | cmake3, libsbc-dev, libnghttp2-dev, libssh-gcrypt-dev,
 liblz4-dev, libsnappy-dev, libzstd-dev, libspandsp-dev, libxml2-dev, libbrotli-dev,
 libspeexdsp-dev
Build-Conflicts: libsnmp4.2-dev, libsnmp-dev
Vcs-Git: https://salsa.debian.org/debian/wireshark -b debian/master
Vcs-Browser: https://salsa.debian.org/debian/wireshark.git
Homepage: https://www.wireshark.org/

Package: wireshark-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libwireshark0 (>= ${binary:Version}),
 libwiretap0 (>= ${binary:Version}), debconf, libcap2-bin [linux-any]
Recommends: wireshark (>= ${binary:Version}) | tshark (>= ${binary:Version})
Breaks: wireshark (<< 2.0.0~),
        wireshark-gtk (<< 3.0.0),
        wireshark-qt (<< 2.0.0~rc3+g841d5e1)
Replaces: wireshark (<< 2.0.0~),
        wireshark-qt (<< 2.0.0~rc3+g841d5e1)
Description: network traffic analyzer - common files
 Wireshark is a network "sniffer" - a tool that captures and analyzes
 packets off the wire. Wireshark can decode too many protocols to list
 here.
 .
 This package provides files common to both wireshark and tshark
 (the console version).

Package: wireshark
Architecture: any
Depends: wireshark-qt (= ${binary:Version}), ${misc:Depends}
Description: network traffic analyzer - meta-package
 Wireshark is a network "sniffer" - a tool that captures and analyzes
 packets off the wire. Wireshark can decode too many protocols to list
 here.
 .
 This is a meta-package for Wireshark.

Package: wireshark-qt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, wireshark-common (= ${binary:Version}),
 libqt5svg5
Recommends: libqt5multimedia5-plugins
Replaces: wireshark (<< 2.0.0~), wireshark-gtk (<< 3.0.0~)
Breaks: wireshark (<< 2.0.0~), wireshark-gtk (<< 3.0.0~)
Description: network traffic analyzer - Qt version
 Wireshark is a network "sniffer" - a tool that captures and analyzes
 packets off the wire. Wireshark can decode too many protocols to list
 here.
 .
 This package provides the Qt version of Wireshark.

Package: tshark
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, wireshark-common (= ${binary:Version})
Description: network traffic analyzer - console version
 Wireshark is a network "sniffer" - a tool that captures and analyzes
 packets off the wire. Wireshark can decode too many protocols to list
 here.
 .
 This package provides the console version of wireshark, named
 "tshark".

Package: wireshark-dev
Architecture: any
Section: devel
Depends: ${misc:Depends}, omniidl (>= 4.0.1-2), libpcap0.8-dev,
 libglib2.0-dev, python3:any, python3-ply, snacc,
 libwireshark-dev, libwiretap-dev
Description: network traffic analyzer - development tools
 Wireshark is a network "sniffer" - a tool that captures and analyzes
 packets off the wire. Wireshark can decode too many protocols to list
 here.
 .
 This package provides idl2wrs and other files necessary for developing
 new packet dissectors.

Package: wireshark-dbg
Architecture: any
Section: debug
Depends: ${misc:Depends}, wireshark-common (= ${binary:Version}) | wireshark (= ${binary:Version}) | tshark (= ${binary:Version})
Description: network traffic analyzer - debug symbols
 Wireshark is a network "sniffer" - a tool that captures and analyzes
 packets off the wire. Wireshark can decode too many protocols to list
 here.
 .
 This package contains stripped debugging symbols for all Wireshark
 programs and libraries.

Package: wireshark-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: network traffic analyzer - documentation
 Wireshark is a network "sniffer" - a tool that captures and analyzes
 packets off the wire. Wireshark can decode too many protocols to list
 here.
 .
 This package contains Wireshark User's guide, Wireshark Developer's Guide
 and the Lua Reference.

Package: libwireshark0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libwireshark-data (>= ${source:Version}),
 libwsutil0 (>= ${source:Version})
Suggests: wireshark-doc (>= ${source:Version})
Description: network packet dissection library -- shared library
 The libwireshark library provides the network packet dissection services
 developed by the Wireshark project.

Package: libwsutil0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: network packet dissection utilities library -- shared library
 The libwsutil library provides utility functions for libwireshark0.

Package: libwsutil-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends} , libwsutil0 (= ${binary:Version})
Description: network packet dissection utilities library -- development files
 The libwsutil library provides utility functions for libwireshark6.
 .
 This package contains the static library and the C header files that are
 needed for applications to use the libwsutil library.

Package: libwireshark-data
Section: libs
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
#Recommends: geoip-database-contrib # Only includes legacy?
Suggests: snmp-mibs-downloader
Description: network packet dissection library -- data files
 The libwireshark library provides the network packet dissection services
 developed by the Wireshark project.
 .
 This package contains the platform independent files.

Package: libwireshark-dev
Section: libdevel
Depends: ${misc:Depends}, libwsutil-dev, libwiretap-dev,
 libwireshark0 (= ${binary:Version})
Architecture: any
Description: network packet dissection library -- development files
 The "libwireshark" library provides the network packet dissection services
 developed by the Wireshark project.
 .
 This package contains the static library and the C header files that are
 needed for applications to use libwireshark services.

Package: libwiretap0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: network packet capture library -- shared library
 Wiretap, part of the Wireshark project, is a library that allows one to
 read and write several packet capture file formats.
 .
 Supported formats are:
  * Libpcap
  * Sniffer
  * LANalyzer
  * Network Monitor
  * "snoop"
  * "iptrace"
  * Sniffer Basic (NetXRay)/Windows Sniffer Pro
  * RADCOM WAN/LAN Analyzers
  * Lucent/Ascend access products
  * HP-UX nettl
  * Toshiba ISDN Router
  * ISDN4BSD "i4btrace" utility
  * Cisco Secure Intrusion Detection System iplogging facility
  * pppd logs (pppdump-format files)
  * VMS TCPTRACE
  * DBS Etherwatch (text format)
  * Catapult DCT2000 (.out files)
 .
 Wiretap's shortcomings are: no filter capability and no support for packet
 capture.

Package: libwiretap-dev
Section: libdevel
Depends: ${misc:Depends}, libwsutil-dev, libwiretap0 (= ${binary:Version})
Architecture: any
Description: network packet capture library -- development files
 Wiretap, part of the Wireshark project, is a library that allows one to
 read and write several packet capture file formats.
 .
 Supported formats are:
  * Libpcap
  * Sniffer
  * LANalyzer
  * Network Monitor
  * "snoop"
  * "iptrace"
  * Sniffer Basic (NetXRay)/Windows Sniffer Pro
  * RADCOM WAN/LAN Analyzers
  * Lucent/Ascend access products
  * HP-UX nettl
  * Toshiba ISDN Router
  * ISDN4BSD "i4btrace" utility
  * Cisco Secure Intrusion Detection System iplogging facility
  * pppd logs (pppdump-format files)
  * VMS TCPTRACE
  * DBS Etherwatch (text format)
  * Catapult DCT2000 (.out files)
 .
 Wiretap's shortcomings are: no filter capability and no support for packet
 capture.
 .
 This package contains the static library and the C header files.
